#include "EncButton.h"
EncButton <EB_TICK, 11> btn_perepravit;    //пины 10,11 для кнопок
EncButton <EB_TICK, 10> btn_vibor;
#define BUZZER_PIN 12                    
unsigned long currentTime;   
boolean ledState = 0;                 
int led_perepravshik_A = 2; //в пины 2-9 подключаем светодиоды
int led_perepravshik_B = 3;
int led_koza_A = 4;
int led_koza_B = 5;
int led_volk_A = 6;
int led_volk_B = 7;
int led_kapusta_A = 8;
int led_kapusta_B = 9;
int i = 0;
int j = 0;
boolean koza = false;
boolean volk = false;
boolean kapusta = false;
boolean vibor_koza_A = false;
boolean vibor_koza_B = false;
boolean vibor_volk_A = false;
boolean vibor_volk_B = false;
boolean vibor_kapusta_A = false;
boolean vibor_kapusta_B = false;
boolean bereg = false;


void setup() {
  pinMode(led_perepravshik_A, OUTPUT);
  pinMode(led_perepravshik_B, OUTPUT);
  pinMode(led_koza_A, OUTPUT);
  pinMode(led_koza_B, OUTPUT);
  pinMode(led_volk_A, OUTPUT);
  pinMode(led_volk_B, OUTPUT);
  pinMode(led_kapusta_A, OUTPUT);
  pinMode(led_kapusta_B, OUTPUT);
  digitalWrite(led_perepravshik_A, HIGH);    //задаём начальное состояние светодиодов
  digitalWrite(led_perepravshik_B, LOW);
  digitalWrite(led_koza_A, HIGH);
  digitalWrite(led_volk_A, HIGH);
  digitalWrite(led_kapusta_A, HIGH);
  digitalWrite(led_koza_B, LOW);
  digitalWrite(led_volk_B, LOW);
  digitalWrite(led_kapusta_B, LOW);
  intro();
}

void loop() {
  btn_perepravit.tick();
  btn_vibor.tick();


  if (btn_perepravit.press()) {

      digitalWrite(led_perepravshik_A,!digitalRead(led_perepravshik_A));
      digitalWrite(led_perepravshik_B,!digitalRead(led_perepravshik_B));
   
  if (bereg==false) {
    if (vibor_koza_A==true) {
      vibor_koza_A = false;
      vibor_koza_B = true;
      koza = true;
      digitalWrite(led_koza_A,LOW);
      digitalWrite(led_koza_B,HIGH);
    }
    if (vibor_volk_A==true) {
      vibor_volk_A = false;
      vibor_volk_B = true;
      volk = true;
      digitalWrite(led_volk_A,LOW);
      digitalWrite(led_volk_B,HIGH);
   }
   if (vibor_kapusta_A==true) {
      vibor_kapusta_A = false;
      vibor_kapusta_B = true;
      kapusta = true;
      digitalWrite(led_kapusta_A,LOW);
      digitalWrite(led_kapusta_B,HIGH);
   }
  } else {
    if (vibor_koza_B==true) {
      vibor_koza_A = true;
      vibor_koza_B = false;
      koza = false;
      digitalWrite(led_koza_A,HIGH);
      digitalWrite(led_koza_B,LOW);
    }
    if (vibor_volk_B==true) {
      vibor_volk_A = true;
      vibor_volk_B = false;
      volk = false;
      digitalWrite(led_volk_A,HIGH);
      digitalWrite(led_volk_B,LOW);
   }
   if (vibor_kapusta_B==true) {
      vibor_kapusta_A = true;
      vibor_kapusta_B = false;
      kapusta = false;
      digitalWrite(led_kapusta_A,HIGH);
      digitalWrite(led_kapusta_B,LOW);
   }
  }

      bereg = !bereg;
      
      if ((bereg==true && koza==false && volk==false && kapusta==false)||
      (bereg==true && koza==false && volk==false && kapusta==true)||
      (bereg==true && koza==false && volk==true && kapusta==false)||
      (bereg==false && koza==true && volk==true && kapusta==false)||
      (bereg==false && koza==true && volk==false && kapusta==true)||
      (bereg==false && koza==true && volk==true && kapusta==true))   {
        oshibka(); 
      } else {
        zvuk2();
      }
      
      if (bereg==true && koza==true && volk==true && kapusta==true) {
        pobeda();
        i = 0;
      }
   }

  if (btn_vibor.press()) {

    tone(BUZZER_PIN, 300, 250);
    delay(100);
    noTone(BUZZER_PIN);

    if (bereg==false) {
      if (koza==false && volk==false && kapusta==false) {        //111
        i++;
        if (i>3) i=0;
      }
      if (koza==true && volk==false && kapusta==false) {         //011
        j++;
        if (j>2) j = 0;
          switch (j) {
          case 0:
            i = 0;
          break;
          case 1:
            i = 2;
          break;
          case 2:
            i = 3;
          break;
          }
        }  
       if (koza==true && volk==true && kapusta==false) {         //001
        j++;
        if (j>1) j = 0;
          switch (j) {
          case 0:
            i = 3;
          break;
          case 1:
            i = 0;
          break;
          }
        } 
       if (koza==false && volk==true && kapusta==true) {        //100
        i++;
        if (i>1) i=0;  
        }  
       if (koza==true && volk==false && kapusta==true) {        //010
        j++;
        if (j>1) j = 0;
          switch (j) {
          case 0:
            i = 2;
          break;
          case 1:
            i = 0;
          break;
        }
       } 
       if (koza==false && volk==false && kapusta==true) {       //110
        i++;
        if (i>2) i=0;
       }
       if (koza==false && volk==true && kapusta==false) {       //101
         j++;
         if (j>2) j = 0;
           switch (j) {
           case 0:
             i = 0;
           break;
           case 1:
             i = 1;
           break;
           case 2:
             i = 3;
           break;
          }
        }
    }
    if (bereg==true) {
      if (koza==true && volk==false && kapusta==false) {       //100
        i++;
        if (i>1) i=0;
      }
      if (koza==true && volk==true && kapusta==false) {        //110
        i++;
        if (i>2) i=0;
      }
      if (koza==true && volk==true && kapusta==true) {         //111
        i++;
        if (i>3) i=0;
      }
      if (koza==false && volk==true && kapusta==true) {        //011
        j++;
        if (j>2) j = 0;
          switch (j) {
          case 0:
            i = 0;
          break;
          case 1:
            i = 2;
          break;
          case 2:
            i = 3;
          break;
          }
        }
      if (koza==false && volk==false && kapusta==true) {       //001
        j++;
        if (j>1) j = 0;
          switch (j) {
          case 0:
            i = 3;
          break;
          case 1:
            i = 0;
          break;
          }
        }
      if (koza==false && volk==true && kapusta==false) {      //010
        j++;
        if (j>1) j = 0;
          switch (j) {
          case 0:
            i = 0;
          break;
          case 1:
            i = 2;
          break;
         }
       }
      if (koza==true && volk==false && kapusta==true) {       //101
        j++;
        if (j>2) j = 0;
          switch (j) {
          case 0:
            i = 0;
          break;
          case 1:
            i = 1;
          break;
          case 2:
            i = 3;
          break;
         }
      } 
    
    }
      
  }    

 switch (i) {
  case 0:
    if (bereg==false) {
      if (vibor_kapusta_A==true) digitalWrite(led_kapusta_A,HIGH);
      if (vibor_koza_A==true) digitalWrite(led_koza_A,HIGH);
      if (vibor_volk_A==true) digitalWrite(led_volk_A,HIGH);
    } else {
      if (vibor_kapusta_B==true) digitalWrite(led_kapusta_B,HIGH);
      if (vibor_koza_B==true) digitalWrite(led_koza_B,HIGH);
      if (vibor_volk_B==true) digitalWrite(led_volk_B,HIGH);
    }
    vibor_koza_A = false;
    vibor_koza_B = false;
    vibor_volk_A = false;
    vibor_volk_B = false;
    vibor_kapusta_A = false;
    vibor_kapusta_B = false;
  break;
  case 1:
    if (bereg==false) {
      vibor_koza_A = true;
      vibor_koza_B = false;
      miganie(led_koza_A);
    } else {
      vibor_koza_A = false;
      vibor_koza_B = true;
      miganie(led_koza_B);
    }
    vibor_volk_A = false;
    vibor_volk_B = false;
    vibor_kapusta_A = false;
    vibor_kapusta_B = false;
  break; 
  case 2:
     if (bereg==false) {
       if (vibor_koza_A==true) digitalWrite(led_koza_A,HIGH);
       vibor_volk_A = true;
       vibor_volk_B = false;
       miganie(led_volk_A); 
     } else {
     if (vibor_koza_B==true) digitalWrite(led_koza_B,HIGH);
       vibor_volk_A = false;
       vibor_volk_B = true;
       miganie(led_volk_B);
     }
     vibor_koza_A = false;
     vibor_koza_B = false;
     vibor_kapusta_A = false;
     vibor_kapusta_B = false;
  break;
  case 3:
      if (bereg==false) {
        if (vibor_koza_A==true) digitalWrite(led_koza_A,HIGH);
        if (vibor_volk_A==true) digitalWrite(led_volk_A,HIGH);
        vibor_kapusta_A = true;
        vibor_kapusta_B = false;
        miganie(led_kapusta_A);
      } else {
        if (vibor_koza_B==true) digitalWrite(led_koza_B,HIGH);
        if (vibor_volk_B==true) digitalWrite(led_volk_B,HIGH);
        vibor_kapusta_A = false;
        vibor_kapusta_B = true;
        miganie(led_kapusta_B);
     }
     vibor_koza_A = false;
     vibor_koza_B = false; 
     vibor_volk_A = false;
     vibor_volk_B = false;
  break; 
 }

}

void miganie(int led) {
  if (millis() - currentTime > 400)   // проверяем сколько прошло миллисекунд
    {
       currentTime = millis();
       ledState=!ledState;                   // меняем состояние светодиода на противоположное
       digitalWrite(led, ledState);
    }
    
}

void oshibka() {
    melody();
    delay(1000);
    bereg = false;
    koza = false;
    volk = false;
    kapusta = false;
    i = 0;
    digitalWrite(led_perepravshik_A, HIGH);
    digitalWrite(led_perepravshik_B, LOW);
    digitalWrite(led_koza_A, HIGH);
    digitalWrite(led_volk_A, HIGH);
    digitalWrite(led_kapusta_A, HIGH);
    digitalWrite(led_koza_B, LOW);
    digitalWrite(led_volk_B, LOW);
    digitalWrite(led_kapusta_B, LOW);
  
}

void melody() {
    tone(BUZZER_PIN, 196, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 196, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 196, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 156, 450.0);
    delay(250.0);

}

void intro() {
    tone(BUZZER_PIN, 262, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 330, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 392, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 523, 300.0);
    delay(500.0);
    tone(BUZZER_PIN, 392, 225.0);
    delay(250.0);
    tone(BUZZER_PIN, 523, 450.0);
    delay(500.0);
    noTone(BUZZER_PIN);
}

void zvuk2() {
     tone(BUZZER_PIN, 392, 500);
     delay(100);
     tone(BUZZER_PIN, 330, 500);
     delay(100);
     tone(BUZZER_PIN, 262, 500);
     delay(200);
     noTone(BUZZER_PIN);
}

void pobeda() {
    tone(BUZZER_PIN, 415, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 466, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 523, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 587, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 523, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 587, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 622, 178.57125);
    delay(198.4125);
    delay(39.6825);
    tone(BUZZER_PIN, 466, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 391, 178.57125);
    delay(198.4125);
    delay(39.6825);
    tone(BUZZER_PIN, 466, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 415, 178.57125);
    delay(198.4125);
    delay(39.6825);
    tone(BUZZER_PIN, 391, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 349, 178.57125);
    delay(198.4125);
    delay(39.6825);
    tone(BUZZER_PIN, 391, 104.910609375);
    delay(116.56734375);
    delay(2.48015625);
    tone(BUZZER_PIN, 311, 178.57125);
    delay(198.4125);
    delay(39.6825);
    tone(BUZZER_PIN, 349, 24.553546875);
    delay(27.28171875);
    delay(2.48015625);
    tone(BUZZER_PIN, 391, 24.553546875);
    delay(27.28171875);
    delay(2.48015625);
    tone(BUZZER_PIN, 415, 24.553546875);
    delay(27.28171875);
    delay(2.48015625);
    tone(BUZZER_PIN, 466, 24.553546875);
    delay(27.28171875);
    delay(2.48015625);
    tone(BUZZER_PIN, 523, 24.553546875);
    delay(27.28171875);
    delay(2.48015625);
    tone(BUZZER_PIN, 587, 24.553546875);
    delay(27.28171875);
    delay(2.48015625);
    tone(BUZZER_PIN, 622, 265.624734375);
    delay(295.13859375);
    noTone(BUZZER_PIN);
}
